<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTDU_TipoParceiroERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTDU_TipoParceiroERP
 * @subpackage Arrays
 */
class ArrayOfTDU_TipoParceiroERP extends AbstractStructArrayBase
{
    /**
     * The TDU_TipoParceiroERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TDU_TipoParceiroERP[]
     */
    public $TDU_TipoParceiroERP;
    /**
     * Constructor method for ArrayOfTDU_TipoParceiroERP
     * @uses ArrayOfTDU_TipoParceiroERP::setTDU_TipoParceiroERP()
     * @param \StructType\TDU_TipoParceiroERP[] $tDU_TipoParceiroERP
     */
    public function __construct(array $tDU_TipoParceiroERP = array())
    {
        $this
            ->setTDU_TipoParceiroERP($tDU_TipoParceiroERP);
    }
    /**
     * Get TDU_TipoParceiroERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TDU_TipoParceiroERP[]|null
     */
    public function getTDU_TipoParceiroERP()
    {
        return isset($this->TDU_TipoParceiroERP) ? $this->TDU_TipoParceiroERP : null;
    }
    /**
     * Set TDU_TipoParceiroERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_TipoParceiroERP[] $tDU_TipoParceiroERP
     * @return \ArrayType\ArrayOfTDU_TipoParceiroERP
     */
    public function setTDU_TipoParceiroERP(array $tDU_TipoParceiroERP = array())
    {
        foreach ($tDU_TipoParceiroERP as $arrayOfTDU_TipoParceiroERPTDU_TipoParceiroERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfTDU_TipoParceiroERPTDU_TipoParceiroERPItem instanceof \StructType\TDU_TipoParceiroERP) {
                throw new \InvalidArgumentException(sprintf('The TDU_TipoParceiroERP property can only contain items of \StructType\TDU_TipoParceiroERP, "%s" given', is_object($arrayOfTDU_TipoParceiroERPTDU_TipoParceiroERPItem) ? get_class($arrayOfTDU_TipoParceiroERPTDU_TipoParceiroERPItem) : gettype($arrayOfTDU_TipoParceiroERPTDU_TipoParceiroERPItem)), __LINE__);
            }
        }
        if (is_null($tDU_TipoParceiroERP) || (is_array($tDU_TipoParceiroERP) && empty($tDU_TipoParceiroERP))) {
            unset($this->TDU_TipoParceiroERP);
        } else {
            $this->TDU_TipoParceiroERP = $tDU_TipoParceiroERP;
        }
        return $this;
    }
    /**
     * Add item to TDU_TipoParceiroERP value
     * @throws \InvalidArgumentException
     * @param \StructType\TDU_TipoParceiroERP $item
     * @return \ArrayType\ArrayOfTDU_TipoParceiroERP
     */
    public function addToTDU_TipoParceiroERP(\StructType\TDU_TipoParceiroERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TDU_TipoParceiroERP) {
            throw new \InvalidArgumentException(sprintf('The TDU_TipoParceiroERP property can only contain items of \StructType\TDU_TipoParceiroERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TDU_TipoParceiroERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TDU_TipoParceiroERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TDU_TipoParceiroERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TDU_TipoParceiroERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TDU_TipoParceiroERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TDU_TipoParceiroERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TDU_TipoParceiroERP
     */
    public function getAttributeName()
    {
        return 'TDU_TipoParceiroERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTDU_TipoParceiroERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
